----------------------------------------------------------------
-- Binary Algorithm, second version (binary_Polynomials2.adb)
--
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Polynomials; use Polynomials;
procedure Binary_Polynomials2 is
   A, B, C, D, F, G, H, Old_B, Old_D, Z, Y, Zero: Polynomial;
   Coef: Natural_Mod_P;
   Alpha, Beta, Old_Beta: Integer;
begin
   for I in 0 .. M loop G(I) := 0; H(I) := 0; F(I) := 0; end loop;
   --F(0) := 237; F(17) := 1;
   F(0) := 237; F(7) := 29; F(14) := 42; F(17) := 1;
   G(1) := 1; G(5) := 47; G(9) := 230; G(15) := 117;
   H(3) := 211; H(9) := 123; H(11) := 7; H(15) := 189;
   --H(0) := 237; 
   --for i in 0 .. m-1 loop h(i) := 117; end loop; h(m) := 0;
   for I in 0 .. M loop Zero(I) := 0; end loop; 
   ----------------------------------------------------------------------------
   A := F; B := H; C := Zero; D := G; Alpha := M; Beta := M-1;

   Put("a = "); for I in 0 .. M-1 loop Put(A(I)); Put("  "); end loop; Put("alpha = "); Put(Alpha); New_Line;
   Put("b = "); for I in 0 .. M-1 loop Put(B(I)); Put("  "); end loop; Put("beta = "); Put(Beta);New_Line; New_Line;

   while Beta >= 0 loop
      if B(0) = 0 then B := Shift_One(B); D := Divide_By_X(D, F); Beta := Beta - 1;
      else 
         Coef := (A(0)*Invert(B(0))) mod P;
         Old_B := B; Old_D := D; Old_Beta := Beta;
         B := Shift_One(Subtract(A, Product(B, Coef))); 
         D := Divide_By_X(Subtract(C, Product(D, Coef)),F);
         if Alpha > Beta then A := Old_B; C := Old_D; Beta := Alpha - 1; Alpha := Old_Beta;
         else Beta := Beta - 1; 
         end if; 
      end if;

      Put("a = "); for I in 0 .. M-1 loop Put(A(I)); Put("  "); end loop; Put("alpha = "); Put(Alpha); New_Line;
      Put("b = "); for I in 0 .. M-1 loop Put(B(I)); Put("  "); end loop; Put("beta = "); Put(Beta);New_Line; New_Line;

   end loop;
   Z := Product(C, Invert(A(0)));
   -----------------------------------------------------------------------------
   Y := Product_Mod_F(Z, H, F);
   Put("g = "); for I in 0 .. M-1 loop Put(G(I)); Put("  "); end loop; New_Line;
   Put("h = "); for I in 0 .. M-1 loop Put(H(I)); Put("  "); end loop; New_Line;
   Put("z = "); for I in 0 .. M-1 loop Put(Z(I)); Put("  "); end loop; New_Line;
   Put("z.h = "); for I in 0 .. M-1 loop Put(Y(I)); Put("  "); end loop; New_Line;
end Binary_Polynomials2;